// Global variables for storing cheked and disabled positions
var chk_state = new Array(8);
for(i = 0; i < 8; i++)
	chk_state[i] = new Array(8);

// Reads the xlm, and sets up data fileds
function setup(xmlData)
{
	inputs = document.getElementsByTagName("input");
	
	for(i = 0; i < 8; i++)
		for(j = 0; j < 8; j++)
			chk_state[i][j] = 0;

	// chekcboxes and radio buttons
	for(i = 0; i < 8; i++)
		document.getElementById('wd1' + i).checked  = getXMLValue(xmlData, 'wd1' + i);
	
	for(i = 0; i < 8; i++)
		document.getElementById('wd2' + i).checked  = getXMLValue(xmlData, 'wd2' + i);
		
	for(i = 1; i <= 2; i++)
		document.getElementById('as' + i).value  = getXMLValue(xmlData, 'as' + i);
		
	for(i = 0; i < 8; i++)
		document.getElementById('io1' + i).checked  = getXMLValue(xmlData, 'io1' + i);	
		
	for(i = 0; i < 8; i++)
		document.getElementById('io2' + i).checked  = getXMLValue(xmlData, 'io2' + i);	

	for(i = 1; i <= 2; i++)
		document.getElementById('tr' + i).value = getXMLValue(xmlData, 'tr' + i);
		
	for(i = 1; i <= 2; i++)
		document.getElementById('mod' + i).value = getXMLValue(xmlData, 'mod' + i);
		
	for(i = 0; i < 8; i++)
		document.getElementById('ai1' + i).checked  = getXMLValue(xmlData, 'ai1' + i);	
		
	for(i = 0; i < 8; i++)
		document.getElementById('ai2' + i).checked  = getXMLValue(xmlData, 'ai2' + i);	

	// set variables
	j = 0;
	k = 0;
	for (i = 0; i < inputs.length; i++)		// start from 1 to skip remote enable checkbox
	{
		if (inputs[i].getAttribute("type") == "checkbox") 
		{
			if(inputs[i].checked)
			{
				chk_state[j][k] = 1;
			}
			
			if((++k) == 8)
			{
				k = 0;
				j++;
			}
		}
	}

	for(i = 0; i < 8; i++)
	{
		if(getXMLValue(xmlData, 'al' + i) == 'true')
			for(j = 0; j < 8; j++)
				chk_state[j][i] = -1; 
	}		
	
	for(i = 0; i < 8; i++)
	{
		if(getXMLValue(xmlData, 'ro1' + i) == 'true')
			for(j = 0; j < 8; j++)
				chk_state[j][i] = -1; 
	}
			
	for(i = 0; i < 8; i++)
	{
		if(getXMLValue(xmlData, 'ro2' + i) == 'true')
			for(j = 0; j < 8; j++)
				chk_state[j][i] = -1; 
	}
		
	for(i = 0; i < 8; i++)
	{
		if(getXMLValue(xmlData, 'ra1' + i) == 'true')
			for(j = 0; j < 8; j++)
				chk_state[j][i] = -1; 
	}

	for(i = 0; i < 8; i++)
	{
		if(getXMLValue(xmlData, 'ra2' + i) == 'true')
			for(j = 0; j < 8; j++)
				chk_state[j][i] = -1; 
	}
	
	// Update checkboxes
	update_chk_state();
	
	// add event onclick
	for (i = 0; i < inputs.length; i++) {
		if (inputs[i].getAttribute("type") == "checkbox") {
			if (inputs[i].addEventListener) {
				inputs[i].addEventListener('click', set_state, false);
			}
			else if (inputs[i].attachEvent){
				inputs[i].attachEvent('onclick', set_state);
			}
			else {
				inputs[i].onclick = set_state;
			}
		}
	}
	
	for (i = 0; i < inputs.length; i++) {
		if (inputs[i].getAttribute("type") == "radio") {
			if (inputs[i].addEventListener) {
				inputs[i].addEventListener('click', select, false);
			}
			else if (inputs[i].attachEvent){
				inputs[i].attachEvent('onclick', select);
			}
			else {
				inputs[i].onclick = select;
			}
		}
	}		
}	

// update checkboxes
function update_chk_state()
{
	inputs = document.getElementsByTagName("input");

	for(i = 0; i < 8; i++)
		for(j = 0; j < 8; j++)
			if(chk_state[j][i] == 1)
			{
				for(k = 0; k < 8; k++)
					if(chk_state[k][i] != 1)
						chk_state[k][i] = -1;
			}		
			
	for(i = 0; i < 8; i++)
		for(j = 0; j < 8; j++)
			if(chk_state[j][i] == 0)
			{
				for(k = 0; k < 8; k++)
					chk_state[k][i] = 0;
			}
					
	j = 0;
	k = 0;
	for (i = 0; i < inputs.length; i++)		// start from 1 to skip remote enable checkbox
	{
		if (inputs[i].getAttribute("type") == "checkbox") 
		{
			if(chk_state[j][k] == -1)
			{
				inputs[i].setAttribute("disabled", "disabled");
			}
			
			if(chk_state[j][k] == 0)
			{
				inputs[i].removeAttribute("disabled");
			}			
			
			if((++k) == 8)
			{
				k = 0;
				j++;
			}
		}
	}
					
}

function set_state() {

	inputs = document.getElementsByTagName("input");
	
	j = 0;
	k = 0;
	for (i = 0; i < inputs.length; i++)		// start from 1 to skip remote enable checkbox
	{
		if (inputs[i].getAttribute("type") == "checkbox") 
		{
			if(inputs[i].checked)
			{
				chk_state[j][k] = 1;
			}
			
			else
			{
				if(chk_state[j][k] != -1)
					chk_state[j][k] = 0;
			}
			
			if((++k) == 8)
			{
				k = 0;
				j++;
			}
		}
	}
	
	update_chk_state();
}
	
	