// Global variables for storing cheked and disabled positions
var chk_state = new Array(8);
for(i = 0; i < 8; i++)
	chk_state[i] = new Array(8);

// Reads the xlm, and sets up data fileds
function setup(xmlData)
{
	inputs = document.getElementsByTagName("input");
	
	for(i = 0; i < 8; i++)
		for(j = 0; j < 8; j++)
			chk_state[i][j] = 0;

	// chekcboxes and radio buttons
	document.getElementById('enr').checked = getXMLValue(xmlData, 'enr');

	for(i = 0; i < 2; i++)
		document.getElementById('rsel' + i).checked  = getXMLValue(xmlData, 'rsel' + i);	
	
	for(i = 0; i < 8; i++)
		document.getElementById('al' + i).checked  = getXMLValue(xmlData, 'al' + i);	

	for(i = 1; i <= 2; i++)
		document.getElementById('rs' + i).value  = getXMLValue(xmlData, 'rs' + i);
		
	for(i = 0; i < 8; i++)
		document.getElementById('ro1' + i).checked  = getXMLValue(xmlData, 'ro1' + i);	
		
	for(i = 0; i < 8; i++)
		document.getElementById('ro2' + i).checked  = getXMLValue(xmlData, 'ro2' + i);	

	for(i = 1; i <= 2; i++)
		document.getElementById('rt' + i).value = getXMLValue(xmlData, 'rt' + i);
		
	for(i = 1; i <= 2; i++)
		document.getElementById('rmd' + i).value = getXMLValue(xmlData, 'rmd' + i);
		
	for(i = 0; i < 8; i++)
		document.getElementById('ra1' + i).checked  = getXMLValue(xmlData, 'ra1' + i);	
		
	for(i = 0; i < 8; i++)
		document.getElementById('ra2' + i).checked  = getXMLValue(xmlData, 'ra2' + i);	
		
	
	// set variables
	j = 0;
	k = 0;
	for (i = 1; i < inputs.length; i++)		// start from 1 to skip remote enable checkbox
	{
		if (inputs[i].getAttribute("type") == "checkbox") 
		{
			if(inputs[i].checked)
			{
				chk_state[j][k] = 1;
			}
			
			if((++k) == 8)
			{
				k = 0;
				j++;
			}
		}
	}
	
	for(i = 0; i < 8; i++)
	{
		if(getXMLValue(xmlData, 'wd1' + i) == 'true')
			for(j = 0; j < 8; j++)
				chk_state[j][i] = -1; 
	}		
		
	for(i = 0; i < 8; i++)
	{
		if(getXMLValue(xmlData, 'wd2' + i) == 'true')
			for(j = 0; j < 8; j++)
				chk_state[j][i] = -1; 
	}
				
	for(i = 0; i < 8; i++)
	{
		if(getXMLValue(xmlData, 'io1' + i) == 'true')
			for(j = 0; j < 8; j++)
				chk_state[j][i] = -1; 
	}
			
	for(i = 0; i < 8; i++)
	{
		if(getXMLValue(xmlData, 'io2' + i) == 'true')
			for(j = 0; j < 8; j++)
				chk_state[j][i] = -1; 
	}

	for(i = 0; i < 8; i++)
	{
		if(getXMLValue(xmlData, 'ai1' + i) == 'true')
			for(j = 0; j < 8; j++)
				chk_state[j][i] = -1; 
	}
		
	for(i = 0; i < 8; i++)
	{
		if(getXMLValue(xmlData, 'ai2' + i) == 'true')
			for(j = 0; j < 8; j++)
				chk_state[j][i] = -1; 
	}	

	// Update checkboxes
	update_chk_state();
	
	// run first time for initializing
	remote_en();
	
	// add event onclick
	for (i = 1; i < inputs.length; i++) {
		if (inputs[i].getAttribute("type") == "checkbox") {
			if (inputs[i].addEventListener) {
				inputs[i].addEventListener('click', set_state, false);
			}
			else if (inputs[i].attachEvent){
				inputs[i].attachEvent('onclick', set_state);
			}
			else {
				inputs[i].onclick = set_state;
			}
		}
	}
	
	if (inputs[0].addEventListener) {
		inputs[0].addEventListener('click', remote_en, false);
	}
	else if (inputs[0].attachEvent){
		inputs[0].attachEvent('onclick', remote_en);
	}
	else {
		inputs[0].onclick = remote_en;
	}
	
	for (i = 0; i < inputs.length; i++) {
		if (inputs[i].getAttribute("type") == "radio") {
			if (inputs[i].addEventListener) {
				inputs[i].addEventListener('click', select, false);
			}
			else if (inputs[i].attachEvent){
				inputs[i].attachEvent('onclick', select);
			}
			else {
				inputs[i].onclick = select;
			}
		}
	}	
}

// update checkboxes
function update_chk_state()
{
	inputs = document.getElementsByTagName("input");

	for(i = 0; i < 8; i++)
		for(j = 0; j < 8; j++)
			if(chk_state[j][i] == 1)
			{
				for(k = 0; k < 8; k++)
					if(chk_state[k][i] != 1)
						chk_state[k][i] = -1;
			}		
			
	for(i = 0; i < 8; i++)
		for(j = 0; j < 8; j++)
			if(chk_state[j][i] == 0)
			{
				for(k = 0; k < 8; k++)
					chk_state[k][i] = 0;
			}
					
	j = 0;
	k = 0;
	for (i = 1; i < inputs.length; i++)		// start from 1 to skip remote enable checkbox
	{
		if (inputs[i].getAttribute("type") == "checkbox") 
		{
			if(chk_state[j][k] == -1)
			{
				inputs[i].setAttribute("disabled", "disabled");
			}
			
			if(chk_state[j][k] == 0)
			{
				inputs[i].removeAttribute("disabled");
			}			
			
			if((++k) == 8)
			{
				k = 0;
				j++;
			}
		}
	}
					
}

function set_state() {

	inputs = document.getElementsByTagName("input");
	
	j = 0;
	k = 0;
	for (i = 1; i < inputs.length; i++)		// start from 1 to skip remote enable checkbox
	{
		if (inputs[i].getAttribute("type") == "checkbox") 
		{
			if(inputs[i].checked)
			{
				chk_state[j][k] = 1;
			}
			
			else
			{
				if(chk_state[j][k] != -1)
					chk_state[j][k] = 0;
			}
			
			if((++k) == 8)
			{
				k = 0;
				j++;
			}
		}
	}
	
	update_chk_state();
}

function remote_en()
{
	inputs = document.getElementsByTagName("input");
	selects = document.getElementsByTagName("select");
	
	if (document.getElementById('enr').checked)
	{
		set_state();
		for( i = 1; i < inputs.length-1; i ++)
			inputs[i].disabled = false;
			
		for( i = 0; i < selects.length; i ++)
			selects[i].disabled = false;	

		select();
		update_chk_state();	

	}
	
	else if(!(document.getElementById('enr').checked))
	{
		for( i = 1; i < inputs.length-1; i ++)
			inputs[i].disabled = true;
			
		for( i = 0; i < selects.length; i ++)
			selects[i].disabled = true;			
	}
}

function select()
{
	var sel;

	inputs = document.getElementsByTagName("input");

	for (i = 0; i < inputs.length; i++)
	{
		if (inputs[i].getAttribute("type") == "radio")
		{
			if(inputs[i].getAttribute("id") == "rsel1")
			{
				if(inputs[i].checked == true)
				{
					sel = 1;
				}
				else
				{
					sel = 0;
				}
			}
		}
	}
	
	if (document.getElementById('enr').checked)
	{
		for (i = 0; i < inputs.length; i++)
		{
			if (inputs[i].getAttribute("type") == "text")
			{
				if(inputs[i].getAttribute("name") == "sip")
				{
					if(sel == 1)
					{
						inputs[i].removeAttribute("disabled");
					}		
					else 
					{
						inputs[i].setAttribute("disabled", "disabled");
					}
				}
			}
		}
	}	
}













